<?php

namespace Nwb\MultiDownloaderClient;

class FileRequest
{
    private $url;
    private $fallbackUrl;
    private $fileOptions = [];

    public function __construct(string $url, string $fallbackUrl = null)
    {
        $this->url = $url;
        $this->fallbackUrl = $fallbackUrl;
    }

    public function url(string $url)
    {
        $this->url = $url;

        return $this;
    }

    public function fallbackUrl(string $fallbackUrl)
    {
        $this->fallbackUrl = $fallbackUrl;

        return $this;
    }

    public function fileOptions(array $fileOptions)
    {
        $this->fileOptions = $fileOptions;

        return $this;
    }

    public function getFileOptions(): array
    {
        return $this->fileOptions;
    }

    public function getUrl(): string
    {
        return $this->url;
    }

    public function getFallbackUrl(): string
    {
        return $this->fallbackUrl;
    }

    public function toArray(): array
    {
        return array_filter([
            'url' => $this->url,
            'fallbackUrl' => $this->fallbackUrl,
            'fileOptions' => $this->fileOptions,
        ]);
    }
}
